package com.hungraim.ltc.governance.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ltc.api.OrganFeignService;
import com.hungraim.ltc.governance.dao.AprOrganMapper;
import com.hungraim.ltc.governance.service.AprOrganService;
import com.hungraim.ltc.pojo.entity.serviceManage.ChAprOrgan;
import com.hungraim.ltc.pojo.vo.governance.AprOrganVO;
import com.hungraim.ltc.util.Result;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;


@Service
@Slf4j
@AllArgsConstructor
public class AprOrganServiceImpl implements AprOrganService {

    private final AprOrganMapper aprOrganMapper;
    private final OrganFeignService organFeignService;

    @Override
    public Page<AprOrganVO> aprOrganList(Page<AprOrganVO> page, Long organId, Boolean isIncluded, String organName, String code) {
        Result<List<Long>> organChild = null;
        List<Long> organIds = null;
        if (organId != null) {
            if (isIncluded == null) {
                isIncluded = false;
            }
            organChild = organFeignService.getOrganChild(organId, isIncluded);
            organIds = organChild.getData();
        }
        return aprOrganMapper.aprOrganList(page, organIds, organName, code);
    }

    @Override
    public void updateAprOrganStatus(String aprOrganId, Short status) {
        ChAprOrgan chAprOrgan = aprOrganMapper.selectById(aprOrganId);
        chAprOrgan.setStatus(status);
        aprOrganMapper.updateById(chAprOrgan);
    }

    @Override
    public void addOrUpdateAprOrgan(ChAprOrgan chAprOrgan, Short updateType) {
        if (chAprOrgan.getAprOrganId() == null) {
            //新增
            chAprOrgan.setEffTime(new Date());
            chAprOrgan.setStatus((short) 0);
            aprOrganMapper.insert(chAprOrgan);
        } else {
            //更新
            ChAprOrgan aprOrgan = aprOrganMapper.selectById(chAprOrgan.getAprOrganId());
            if (updateType == 1) {//账户信息修改
                aprOrgan.setAccName(chAprOrgan.getAccName());
                aprOrgan.setBankAccName(chAprOrgan.getBankAccName());
                aprOrgan.setBankNo(chAprOrgan.getBankNo());
                aprOrgan.setBankDistrictProvincial(chAprOrgan.getBankDistrictProvincial());
                aprOrgan.setBankDistrictCity(chAprOrgan.getBankDistrictCity());
                aprOrgan.setBankDistrictWebsite(chAprOrgan.getBankDistrictWebsite());
                aprOrgan.setCardType(chAprOrgan.getCardType());
                aprOrgan.setRemark(chAprOrgan.getRemark());
                aprOrganMapper.updateById(aprOrgan);
            } else {//基本信息修改
                aprOrgan.setDistrictProvincial(chAprOrgan.getDistrictProvincial());
                aprOrgan.setDistrictCity(chAprOrgan.getDistrictCity());
                aprOrgan.setDistrictArea(chAprOrgan.getDistrictArea());
                aprOrgan.setUnifiedSocialCreditCode(chAprOrgan.getUnifiedSocialCreditCode());
                aprOrgan.setOrganTypeId(chAprOrgan.getOrganTypeId());
                aprOrgan.setAcptArea(chAprOrgan.getAcptArea());
                aprOrgan.setAcptAddress(chAprOrgan.getAcptAddress());
                aprOrgan.setAcptStreet(chAprOrgan.getAcptStreet());
                aprOrgan.setLinkName(chAprOrgan.getLinkName());
                aprOrgan.setLinkTel(chAprOrgan.getLinkTel());
                aprOrgan.setGroupDetailId(chAprOrgan.getGroupDetailId());
                aprOrgan.setLinkMail(chAprOrgan.getLinkMail());
                aprOrganMapper.updateById(aprOrgan);
            }
        }
    }

    @Override
    public ChAprOrgan getAprOrganInfo(Long aprOrganId) {
        return aprOrganMapper.selectById(aprOrganId);
    }
}
